SystemOrganization addCategory: #'Glamour-Tools'!

Object subclass: #GLMBrowserTemplate
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 12/29/2009 03:33'!
openOn: anEntity
	^ self new openOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'accessing' stamp: 'tg 12/29/2009 03:41'!
browser
	^ browser ifNil: [self buildBrowser. browser]! !

!GLMBrowserTemplate methodsFor: 'building' stamp: 'tg 12/15/2009 13:54'!
buildBrowser
	^ self subclassResponsibility! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:30'!
openOn: anEntity
	^ self browser openOn: anEntity! !

GLMBrowserTemplate subclass: #GLMChasingBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMChasingBrowser commentStamp: 'tg 12/29/2009 03:58' prior: 0!
self openOn: #buildBrowser!

!GLMChasingBrowser methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 03:57'!
buildBrowser
	| finder |
	finder := GLMFinder new.
	finder tree
		display: [ :each | self systemNavigation allImplementorsOf:	each ];
		format: [:each | 
			(each isKindOf: MethodReference) ifTrue: [each classSymbol, '>>', each selector ] ifFalse: [ each ]];
		children: [ :each | 
			(each isKindOf: MethodReference) ifTrue: [each compiledMethod messages] ifFalse: [OrderedCollection new]];
		whenKindOf: String.
	browser := GLMTabulator new.
	browser title: [:each | 'Chasing Browser of ', each].
	browser row: #finder; row: #details.
	browser showOn: #finder; using: [browser custom: finder].
	browser showOn: #details; from: #finder; using: [
		browser text
			forSmalltalk: [:reference | reference actualClass ];
			display: [:reference | reference sourceCode ];
			whenKindOf: MethodReference ].
	^ browser! !

GLMBrowserTemplate subclass: #GLMClassicCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMClassicCodeBrowser commentStamp: 'tg 12/29/2009 04:03' prior: 0!
self openOn: Smalltalk organization categories.!

!GLMClassicCodeBrowser methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:05'!
buildBrowser
	| lintBrowser |
	browser := GLMTabulator new.
	browser
		row: #navigation;
		row: #sourceCode.
	browser
		showOn: #navigation;
		using: [ browser custom: GLMClassicCodeNavigator new browser ].
	browser
		showOn: #sourceCode;
		from: #navigation -> #selectedClass;
		from: #navigation -> #selectedMethod;
		from: #navigation -> #selectedClassCategory;
		using: 
			[ browser text
				title: 'Method source';
				display: [ :class :method | class sourceCodeAt: method ];
				forSmalltalk: [ :class | class ].
			browser text
				forSmalltalk;
				useExplicitNotNil;
				title: 'Class definition';
				display: [ :class | class definition ];
				when: [:class | class notNil].
			browser text
				title: 'Class comment';
				display: [ :class | class comment ];
				useExplicitNotNil;
				when: [:class | class notNil].
			lintBrowser := GLMLintBrowser new browser.
			lintBrowser allowNil; when: [:clas :mth | clas notNil ].
			browser custom: lintBrowser
		].
	"for updating selection through lintBrowser"
	"browser sendTo: #navigator->#faultyMethod from: #source->#faultyMethod."
	^ browser! !

GLMBrowserTemplate subclass: #GLMClassicCodeNavigator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMClassicCodeNavigator commentStamp: 'tg 12/29/2009 04:04' prior: 0!
self openOn: Smalltalk organization categories.!

!GLMClassicCodeNavigator methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:04'!
buildBrowser
	browser := GLMTabulator new.
	browser
		column: #classCats;
		column: #classes;
		column: #categories;
		column: #methods.
	browser
		showOn: #classCats;
		using: 
			[ browser list ].
	browser
		showOn: #classes;
		from: #classCats;
		using: [
			browser tree
				display: [ :classCat | 
					(Smalltalk organization listAtCategoryNamed: classCat) collect: [ :className | Smalltalk classNamed: className ] ];
				children: [ :each | each traitComposition traits ];
				title: 'Class list'.
			browser mondrian 
				painting: [ :view :package |
					view nodes: ((Smalltalk organization listAtCategoryNamed: package) collect: [:name | Smalltalk classNamed: name]).
					view edgesFrom: #superclass.
					view treeLayout.];
				title: 'Hierarchy'.
 ].
	browser
		showOn: #categories;
		from: #classes;
		using: [ browser list display: [ :class | class organization categories ] ].
	browser
		showOn: #methods;
		from: #classes;
		from: #categories;
		using: 
			[ browser list
				display: 
					[ :class :category | 
					(class organization listAtCategoryNamed: category) asSortedCollection].
			browser list
				useExplicitNotNil;
				when: [ :class :category | class notNil and: [ category isNil ] ];
				display: [ :class :category | class selectors asSortedCollection ] ].
	browser 
		sendToOutside: #selectedClassCategory
		from: #classCats.
	browser 
		sendToOutside: #selectedClass
		from: #classes.
	browser 
		sendToOutside: #selectedMethod
		from: #methods.
	"for updating selection from lintBrowser"
	"browser 
		sendTo: #methods -> #selection
		fromOutside: #faultyMethod."
	^ browser! !

GLMBrowserTemplate subclass: #GLMDiffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMDiffer commentStamp: 'tg 12/29/2009 03:52' prior: 0!
self openOn: Collection withAllSubclasses!

!GLMDiffer methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 03:51'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous Diff Browser'.
	browser
		row: [:r | r column: #left; column: #right ];
		row: #diff.
	browser showOn: #left; using: [browser custom: GLMSimpleClassesBrowser new browser ].
	browser showOn: #right; using: [browser custom: GLMSimpleClassesBrowser new browser ].
	browser showOn: #diff; 
		from: #left->#selectedClass; from: #left->#selectedMethod;
		from: #right->#selectedClass; from: #right->#selectedMethod;
		using: [
		browser diff
			display: [:leftClass :leftMethod :rightClass :rightMethod | 
				Array with: (leftClass sourceCodeAt: leftMethod) with: (rightClass sourceCodeAt: rightMethod)
			]
		].
	^ browser! !

GLMBrowserTemplate subclass: #GLMGlobalBrowserTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

GLMGlobalBrowserTemplate subclass: #GLMCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMCodeBrowser commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GLMCodeBrowser classSide methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:49'!
defaultEnvironment
	^ GLMSTModel defaultEnvironment! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 11/16/2009 15:11'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous ST Browser'.
	self layout.
	self onPackages.
	self onClassesFromPackages.
	self onInstVarsFromClasses.
	self onMethodsFromClasses.
	self onMethodsFromInstVars.
	self onDetailsFromPackagesFromClassesFromMethods.
	browser sendTo: #outer->#focusOnMethod from: #details->#focusOnMethod with: [:m | m ].
	browser sendTo: #packages->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior glmPackage].
	browser sendTo: #classes->#selection from: #outer->#focusOnMethod with: [:method | method glmBehavior ].
	browser sendTo: #methods->#selection from: #outer->#focusOnMethod with: [:method | method ]! !

!GLMCodeBrowser methodsFor: 'opening' stamp: 'tg 12/29/2009 03:29'!
entity 
	^ GLMSTPackage rootPackagesOn: self class defaultEnvironment! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 09:36'!
layout
	browser
		column: #packages;
		column: [:c | c row: #classes; row: #instVars ];
		column: [:c | c row: #methods; row: #details] span: 3.! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 9/18/2009 11:49'!
onClassesFromPackages
	browser
		showOn: #classes; from: #packages;
		using: [browser tree
					when: [:package | package isCollection not];
					display: [:package | package allClasses];
					children: [ :each | each traits ];
					icon: [ :each | 
						each stBehavior theNonMetaClass browserIcon isNil ifFalse: 
							[ OBMorphicIcons iconNamed: each stBehavior theNonMetaClass browserIcon ]
						ifTrue: [ nil ] ];
					format: [:class | class name]]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:41'!
onDetailsFromPackagesFromClassesFromMethods
	browser
		showOn: #details; from: #classes; from: #methods; from: #packages; 
		using: [
			browser text
					forSmalltalk: [:class | class stBehavior ];
					title: 'Method';
					display: [:class :method | method sourceCode ].
			browser text
					forSmalltalk;
					title: 'Class';
					useExplicitNotNil;
					when: [:class :method | class notNil and: [method isNil]];
					display: [:class | class definition ].
			browser list
					title: 'References';
					useExplicitNotNil;
					when: [:class | class notNil ];
					display: [:class | class references];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
			browser list
					title: 'Senders';
					display: [:class :method | method senders];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
			browser list
					title: 'Implementors';
					display: [:class :method | method implementors];
					format: [:each | each glmBehavior name, '>>', each name];
					update: #focusOnMethod on: $f entitled: 'Jump there' with: [:list | list selection ].
		]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:40'!
onInstVarsFromClasses
	browser showOn: #instVars; from: #classes; using: [ 
		browser list
				display: [ :class | class instVars ];
				tags: [ :each | 
					{ each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST'] } ] ]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:40'!
onMethodsFromClasses
	browser showOn: #methods; from: #classes; using: [ 
		browser list
				display: [ :class | class instanceAndMetaMethods ];
				tags: [ :each | 
					{each glmCategory name.
					each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST']} ] ]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'TestRunner 11/15/2009 18:40'!
onMethodsFromInstVars
	browser showOn: #methods; from: #instVars; using: [ 
		browser list
				display: [ :var | var accessingMethods ];
				tags: [ :each | 
					{each glmCategory name.
					each glmBehavior isMetaSide ifTrue: ['META'] ifFalse: ['INST']} ] ]! !

!GLMCodeBrowser methodsFor: 'building' stamp: 'tg 10/17/2009 17:08'!
onPackages
	browser
		showOn: #packages;
		using: 
			[ browser tree
				children: [ :package | package subPackages ];
				format: [ :package | package name ];
				filterOn: [ :text :each | text match: each name ] ]! !

!GLMGlobalBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self new
		open! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
entity
	^ self subclassResponsibility! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self openOn: self entity! !

GLMGlobalBrowserTemplate subclass: #GLMMetacelloBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMMetacelloBrowser commentStamp: 'tg 12/29/2009 03:22' prior: 0!
self open!

!GLMMetacelloBrowser methodsFor: 'building' stamp: 'tg 12/19/2009 11:10'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Metacello Browser'.
	browser column: #configs; column: #versions; column: #packages span: 2.
	browser showOn: #configs; using: [
		browser list
			act: [:list  | list selection browse ] entitled: 'Browse implementation';
			act: [:list  | list selection project inspect] entitled: 'Inspect' ].
	browser showOn: #versions; from: #configs; using: [
		browser list
			title: 'Versions';
			display: [:config | config project versions ];
			format: [:each | each versionNumber asString ];
			act: [:list  | list selection inspect] entitled: 'Inspect'.
		browser mondrian
			title: 'Imports';
			painting: [:view :config | self viewVersionMapOf: config on: view]].
	browser showOn: #packages; from: #versions; using: [
		browser list
			title: 'Items';
			display: [:version | version spec packages packageSpecsInLoadOrder];
			format: [:packageSpec | ((packageSpec isKindOf: MetacelloPackageSpec) and: [
					self packageSpecNeedsSaving: packageSpec])
				ifTrue: [Text string: packageSpec name attribute: TextColor blue] ifFalse: [packageSpec name]] ;
			act: [:list  | list selection inspect] entitled: 'Inspect'.
 		browser mondrian
			title: 'Dependencies';
			painting: [:view :version | self viewDependenciesOf: version on: view].
		browser list
			title: 'Newer in repository?';
			display: [:version | version spec packages packageSpecsInLoadOrder];
			format: [:packageSpec | ((packageSpec isKindOf: MetacelloPackageSpec) and: [
					self packageSpecHasNewerVersions: packageSpec])
				ifTrue: [Text string: packageSpec name attribute: TextColor red] ifFalse: [packageSpec name]];
			act: [:list  | list selection inspect] entitled: 'Inspect'
	].
	^ browser ! !

!GLMMetacelloBrowser methodsFor: 'opening' stamp: 'tg 12/29/2009 03:29'!
entity 
	^ (Object subclasses select: [:each | each isMetacelloConfig ]) sort: [:a :b | a name < b name]! !

!GLMMetacelloBrowser methodsFor: 'private' stamp: 'tg 12/15/2009 13:58'!
packageSpecHasNewerVersions: aPackageSpec
	| copy |
	copy := aPackageSpec workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy possiblyNewerVersions notEmpty! !

!GLMMetacelloBrowser methodsFor: 'private' stamp: 'tg 12/15/2009 13:58'!
packageSpecNeedsSaving: aPackageSpec
	| copy |
	copy := aPackageSpec workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

!GLMMetacelloBrowser methodsFor: 'private' stamp: 'tg 12/15/2009 14:02'!
viewDependenciesOf: version on: view
	| all | 
	all := Dictionary new.
	version packages do: [:each | all at: each name put: each].
	version projects do: [:each | all at: each name put: each].
	view shape label text: [:each | each name ].
	view nodes: all values.
	view shape curvedLine.
	view edges: version packages from: [:eachPackage | all at: eachPackage name] toAll: [:eachPackage |
		eachPackage requires collect: [:each | all at: each ]].
	view horizontalDominanceTreeLayout! !

!GLMMetacelloBrowser methodsFor: 'private' stamp: 'tg 12/19/2009 11:09'!
viewVersionMapOf: configClass on: view

	| prag1 prag2 nodes edges version imported |
	prag1 := Pragma allNamed: #version:imports: in: configClass.
	prag2 := Pragma allNamed: #version: in: configClass.
	nodes := Dictionary new.
	edges := OrderedCollection new.
	prag2 do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)) ].
	prag1 do: [:prag | 
		version := nodes at: (prag argumentAt: 1) put: (configClass project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [configClass project version: eachImportPrag].
			edges add: version -> imported.
			]
		].
	view shape label text: [:each | each versionNumber printString].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

GLMBrowserTemplate subclass: #GLMLintBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMLintBrowser commentStamp: 'tg 12/29/2009 03:55' prior: 0!
self openOn: GLMPresentation withAllSubclasses asOrderedCollection!

!GLMLintBrowser methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:00'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Lint Browser'.
	browser column: #groups; column: #rules; column: #results.
	browser showOn: #groups; using: [
		browser list
			display: [:dic | RBCompositeLintRule lintChecks rules];
			allowNil;
			format: #name ].
	browser showOn: #rules; from: #groups; using: [
		browser list
			display: [:group | group rules];
			format: #name ].
	browser showOn: #results; from: #rules; from: #outer->#entity; using: [
		browser list
			display: [:rule :tuple | self getLintResult:
					(self runRule: rule forClass: tuple) result] ].
			"tuple = {class. selector} from the browser. We select the class"
	browser sendToOutside: #faultyMethod from: #results->#selection.
	^ browser! !

!GLMLintBrowser methodsFor: 'private' stamp: 'tg 12/29/2009 03:54'!
getLintResult: anEnvironment

	| results stream |
	results := OrderedCollection new.
	anEnvironment classesAndSelectorsDo: [:class :sel |
			results add: sel].
	^ results! !

!GLMLintBrowser methodsFor: 'private' stamp: 'tg 12/29/2009 03:54'!
runRule: aRule forClass: aClass

	| environment |
	environment := BrowserEnvironment new
 		forClasses: { aClass }.
	^ SmalllintChecker runRule: aRule onEnvironment: environment! !

GLMBrowserTemplate subclass: #GLMMessageTallyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMMessageTallyBrowser commentStamp: 'tg 12/29/2009 03:35' prior: 0!
self openOn: [10000 timesRepeat: [1.23 printString]]!

!GLMMessageTallyBrowser methodsFor: 'building' stamp: 'tg 12/29/2009 03:41'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Message Tally'.
	browser column: #messages; column: #details.
	browser showOn: #messages; using: [
		browser tree
			children: [:each | each sonsOver: -1 ];
			format: [:each | Text fromString: (each printString, ' (', each tally printString, ')')]].
	browser showOn: #details; from: #messages; using: [
		browser text
			forSmalltalk: [:each | each method methodClass];
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]].
	^ browser! !

!GLMMessageTallyBrowser methodsFor: 'building' stamp: 'tg 12/29/2009 03:36'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself)! !

GLMBrowserTemplate subclass: #GLMMessageTallyFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMMessageTallyFinder commentStamp: 'tg 12/29/2009 04:07' prior: 0!
self openOn: [10000 timesRepeat: [1.23 printString]]!

!GLMMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:08'!
buildBrowser
	| finder |
	finder := GLMFinder new.
	finder list
		title: 'Messages';
		display: [:each | each sonsOver: -1];
		format: [:each | each printString, ' (', each tally printString, ')'].
	browser := GLMTabulator new.
	browser row: #messages; row: #source.
	browser showOn: #messages; using: [browser custom: finder].
	browser showOn: #source; from: #messages; using: [
		browser text
			title: 'Source';
			forSmalltalk: [:each | each method methodClass];			
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]
	].
	browser 
		act: [:x |
			(StringHolder new contents: (String streamContents: [:s | x entity report: s; close])) openLabel: 'Spy Results' wrap: false.]
		entitled: 'Print report'.	
	^ browser! !

!GLMMessageTallyFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 04:07'!
openOn: aBlock
	^ super openOn: (MessageTally new spyEvery: 1 on: aBlock; yourself)! !

GLMBrowserTemplate subclass: #GLMObjectFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMObjectFinder commentStamp: 'tg 12/29/2009 03:43' prior: 0!
self openOn: Smalltalk!

!GLMObjectFinder methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 03:41'!
buildBrowser
	browser := GLMFinder new.
	browser list
		title: [ :anObject | self printObjectAsAnItem: anObject ];
		display: 
			[ :anObject | 
			anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv) ] ];
		format: [ :assoc | assoc key asString , ' : ' , (assoc value printString copyFrom: 1 to: ((50 min: assoc value printString size) max: 0)) ];
		send: #value.
	browser list
		title: 'Collection';
		when: [ :each | each isCollection ].
	browser text
		forSmalltalk;
		display: [ :entity | 'self' ];
		title: 'Evaluator';
		update: #selection
			on: $o
			entitled: 'Open (o)'
			with: 
				[ :text :entity | 
				Compiler 
					evaluate: text selectedText
					for: entity
					logged: false ];
		act: 
				[ :text :entity | 
				(Compiler 
					evaluate: text selectedText
					for: entity
					logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)'.
	^ browser! !

!GLMObjectFinder methodsFor: 'private' stamp: 'tg 12/29/2009 03:43'!
printObjectAsAnItem: anObject 
	| title stream |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	^ stream contents! !

GLMBrowserTemplate subclass: #GLMSimpleClassesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSimpleClassesBrowser commentStamp: 'tg 12/29/2009 03:50' prior: 0!
self openOn: Collection withAllSubclasses!

!GLMSimpleClassesBrowser methodsFor: 'as yet unclassified' stamp: 'tg 12/29/2009 03:50'!
buildBrowser
	browser := GLMTabulator new.
	browser column: #classes; column: #methods.
	browser showOn: #classes; using: [
		browser list
			display: [:classes | classes asOrderedCollection sortBy: [:a :b | a name < b name] ]].
	browser showOn: #methods; from: #classes; using: [
		browser list
			display: [:cls | cls selectors asOrderedCollection sortBy: [:a :b | a < b]]].
	browser sendToOutside: #selectedClass from: #classes.
	browser sendToOutside: #selectedMethod from: #methods.
	^ browser! !

Object subclass: #GLMSTModel
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTModel classSide methodsFor: 'defaults' stamp: 'DamienCassou 9/14/2009 08:43'!
defaultEnvironment
	^ BrowserEnvironment new! !

!GLMSTModel methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:46'!
= anObject
	^ self class = anObject class and: [self name = anObject name ]! !

!GLMSTModel methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:42'!
environment
	^ environment ifNil: [environment := self class defaultEnvironment]! !

!GLMSTModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:42'!
environment: anObject
	environment := anObject! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 16:16'!
isCategory
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isClass
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isClassCategory
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isMethod
	^ false! !

!GLMSTModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:46'!
name
	self subclassResponsibility! !

!GLMSTModel methodsFor: 'printing' stamp: 'tg 9/6/2009 16:12'!
printOn: aStream
	aStream nextPutAll: self name! !

GLMSTModel subclass: #GLMSTNamedModel
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

GLMSTNamedModel subclass: #GLMSTBehavior
	instanceVariableNames: 'stBehavior instanceAndMetaMethods methods instVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTBehavior classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:52'!
behavior: aBehavior environment: anEnvironment
	^ self new
		stBehavior: aBehavior;
		environment: anEnvironment;
		yourself! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:38'!
comment
	^ self stBehavior comment! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:38'!
definition
	^ self stBehavior definition! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:41'!
glmPackage
	^ GLMSTPackage named: (PackageOrganizer default mostSpecificPackageOfClass: self stBehavior) packageName environment: self environment! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/18/2009 09:52'!
instVars
	^ instVars ifNil: [
		instVars := self stBehavior instVarNames collect: [:each | 
			GLMSTVariable new name: each; glmBehavior: self; yourself ] ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/15/2009 00:33'!
instanceAndMetaMethods
	^ instanceAndMetaMethods ifNil: [ instanceAndMetaMethods := (self methods, self metaSide methods) asSortedCollection: [:a :b | a name < b name] ]! !

!GLMSTBehavior methodsFor: 'testing' stamp: 'tg 9/14/2009 11:14'!
isMetaSide 
	^ self stBehavior class = Metaclass ! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/19/2009 09:46'!
metaSide
	^ (GLMSTClass named: self name) 
		stBehavior: self stBehavior class;
		yourself! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/15/2009 01:11'!
methods
	^ methods ifNil: [
		methods := OrderedCollection new.
		self protocols do: [:each |
			methods addAll: each methods ].
		methods ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:12'!
name
	^ self stBehavior name! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:04'!
protocols
	^ (self environment protocolsFor: self stBehavior) collect: 
		[ :each | 
		GLMSTProtocol new
			name: each;
			glmBehavior: self;
			yourself ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:16'!
references
	| association |
	association := Smalltalk associationAt: self name ifAbsent: [ ^ #() ].
	^ (self systemNavigation allCallsOn: association) collect: [ :each |
		GLMSTMethod fromMethodReference: each ]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:39'!
sourceCodeAt: aSelector
	^ self stBehavior sourceCodeAt: aSelector! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:54'!
stBehavior
	^ stBehavior! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:27'!
stBehavior: anObject
	stBehavior := anObject! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:55'!
traits
	^ self stBehavior traitComposition traits collect: [:each |
		GLMSTTrait new stBehavior: each; yourself]! !

GLMSTBehavior subclass: #GLMSTClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTClass methodsFor: 'accessing' stamp: 'tg 11/6/2009 11:15'!
superclass
	self class behavior: self stBehavior superclass environment: self environment
! !

GLMSTBehavior subclass: #GLMSTTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

GLMSTNamedModel subclass: #GLMSTClassCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTClassCategory classSide methodsFor: 'as yet unclassified' stamp: 'tg 12/10/2009 22:58'!
all
	|env|
	env := self defaultEnvironment.
	^ env categories collect: [:each | self named: each environment: env]! !

!GLMSTClassCategory methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:43'!
classes
	^ (Smalltalk organization listAtCategoryNamed: self name) collect: [ :className |
		GLMSTClass behavior: (Smalltalk classNamed: className) environment: self environment]! !

GLMSTNamedModel subclass: #GLMSTMethod
	instanceVariableNames: 'glmCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTMethod classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/18/2009 11:21'!
fromMethodReference: aMethodReference
	| cls cat |
	cls := GLMSTClass new.
	cls stBehavior: (Smalltalk at: aMethodReference classSymbol).
	cat := GLMSTProtocol new.
	cat name: aMethodReference category.
	cat glmBehavior: cls.
	^ GLMSTMethod new
		name: aMethodReference methodSymbol;
		glmCategory: cat;
		yourself! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/14/2009 11:16'!
glmBehavior 
	^ self glmCategory glmBehavior ! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:42'!
glmCategory
	^ glmCategory! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:42'!
glmCategory: anObject
	glmCategory := anObject! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/18/2009 10:58'!
implementors
	^ (self systemNavigation allImplementorsOf:	self name) collect: [:each | 
			GLMSTMethod fromMethodReference: each ]! !

!GLMSTMethod methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isMethod
	^ true! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/18/2009 10:58'!
senders
	^ (self systemNavigation allSendersOf:	self name) collect: [:each | 
			GLMSTMethod fromMethodReference: each ]! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:59'!
sourceCode
	^ self glmCategory glmBehavior sourceCodeAt: self name! !

!GLMSTNamedModel classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:47'!
named: aString
	^ self named: aString environment: self defaultEnvironment! !

!GLMSTNamedModel classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:47'!
named: aString environment: anEnvironment
	^ self new
		name: aString;
		environment: anEnvironment;
		yourself! !

!GLMSTNamedModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:45'!
name
	^ name! !

!GLMSTNamedModel methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:45'!
name: anObject
	name := anObject! !

GLMSTNamedModel subclass: #GLMSTPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTPackage classSide methodsFor: 'instance creation' stamp: 'DamienCassou 9/14/2009 08:51'!
named: aString environment: anEnvironment
	^ self new
		name: aString;
		environment: anEnvironment;
		yourself! !

!GLMSTPackage classSide methodsFor: 'instance creation' stamp: 'tg 12/10/2009 22:58'!
rootPackagesOn: anEnvironment
	^ ((anEnvironment categories collect: [:string | string readStream upTo: $-]) asSet asSortedCollection)
			collect: [:string | self named: string environment: anEnvironment]! !

!GLMSTPackage methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:50'!
allClasses
	| all |
	all := self classes asOrderedCollection.
	self subPackages do: [:each | 
		all addAll: each allClasses ].
	^ all! !

!GLMSTPackage methodsFor: 'accessing' stamp: 'tg 9/18/2009 11:38'!
classes
	^ (self environment classNamesFor: self name)
		collect: [:className | GLMSTClass behavior: (self environment at: className) environment: self environment ]! !

!GLMSTPackage methodsFor: 'accessing' stamp: 'tg 12/10/2009 22:57'!
subPackages
	^ self environment categories
		select: [:string | string  beginsWith: self name, '-']
		thenCollect: [:string  | self class named: string environment: self environment]! !

GLMSTNamedModel subclass: #GLMSTProtocol
	instanceVariableNames: 'glmBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTProtocol methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:59'!
glmBehavior
	^ glmBehavior! !

!GLMSTProtocol methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 09:00'!
glmBehavior: anObject 
	glmBehavior := anObject! !

!GLMSTProtocol methodsFor: 'testing' stamp: 'tg 9/6/2009 16:16'!
isCategory
	^ true! !

!GLMSTProtocol methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2009 08:59'!
methods
	^ (self glmBehavior stBehavior organization listAtCategoryNamed: self name) asSortedCollection collect: 
		[ :each | 
		GLMSTMethod new
			name: each;
			glmCategory: self;
			yourself ]! !

GLMSTNamedModel subclass: #GLMSTVariable
	instanceVariableNames: 'glmBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMSTVariable methodsFor: 'accessing' stamp: 'tg 9/18/2009 10:47'!
accessingMethods
	| selectors |
	selectors := self glmBehavior stBehavior whichSelectorsAccess: self name.
	^ self glmBehavior methods select: [:each | selectors includes: each name ]! !

!GLMSTVariable methodsFor: 'accessing' stamp: 'tg 9/18/2009 09:38'!
glmBehavior
	^ glmBehavior! !

!GLMSTVariable methodsFor: 'accessing' stamp: 'tg 9/18/2009 09:38'!
glmBehavior: anObject
	glmBehavior := anObject! !
